import $hgUW1$react, {useRef as $hgUW1$useRef, useEffect as $hgUW1$useEffect} from "react";
import {init as $hgUW1$init} from "echarts";

function $parcel$exportWildcard(dest, source) {
  Object.keys(source).forEach(function(key) {
    if (key === 'default' || key === '__esModule' || dest.hasOwnProperty(key)) {
      return;
    }

    Object.defineProperty(dest, key, {
      enumerable: true,
      get: function get() {
        return source[key];
      }
    });
  });

  return dest;
}
function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
var $a69491ea5a126553$exports = {};
var $13be92b15e2953e0$exports = {};
var $9dc45b7702debb40$exports = {};

$parcel$export($9dc45b7702debb40$exports, "EChart", () => $9dc45b7702debb40$export$264f98ddc7eb5f58);

var $ca43fe01b6155439$exports = {};
var $50eed8186559fb03$exports = {};

$parcel$export($50eed8186559fb03$exports, "useECharts", () => $50eed8186559fb03$export$8213d87793e4a80e);


var $77503970b015f24f$exports = {};

$parcel$export($77503970b015f24f$exports, "EChartEvents", () => $77503970b015f24f$export$7e005d5daa5fc91b);
let $77503970b015f24f$export$7e005d5daa5fc91b;
(function(EChartEvents) {
    EChartEvents["onClick"] = "click";
    EChartEvents["onDoubleClick"] = "dblclick";
    EChartEvents["onMouseDown"] = "mousedown";
    EChartEvents["onMouseMove"] = "mousemove";
    EChartEvents["onMouseOver"] = "mouseover";
    EChartEvents["onMouseOut"] = "mouseout";
    EChartEvents["onGlobalOut"] = "globalout";
    EChartEvents["onContextMenu"] = "contextmenu";
    EChartEvents["onHighlight"] = "highlight";
    EChartEvents["onDownplay"] = "downplay";
    EChartEvents["onSelectChanged"] = "selectchanged";
    EChartEvents["onLegendSelectChanged"] = "legendsselectchanged";
    EChartEvents["onLegendSelected"] = "legendselected";
    EChartEvents["onLegendUnselected"] = "legendunselected";
    EChartEvents["onLegendInverseSelect"] = "legendinverseselect";
    EChartEvents["onLegendScroll"] = "legendscroll";
    EChartEvents["onDataZoom"] = "datazoom";
    EChartEvents["onDataRangeSelected"] = "datarangeselected";
    EChartEvents["onTimelineChanged"] = "timelinechanged";
    EChartEvents["onTimelinePlayChanged"] = "timelineplaychanged";
    EChartEvents["onRestore"] = "restore";
    EChartEvents["onDataViewChanged"] = "dataviewchanged";
    EChartEvents["onMagicTypeChanged"] = "magictypechanged";
    EChartEvents["onGeoSelectChanged"] = "geoselectchanged";
    EChartEvents["onGeoSelected"] = "geoselected";
    EChartEvents["onGeoUnselected"] = "geounselected";
    EChartEvents["onAxisAreaSelected"] = "axisareaselected";
    EChartEvents["onFocusNodeadJacency"] = "focusnodeadjacency";
    EChartEvents["onUnfocusNodeAdjacency"] = "unfocusnodeadjacency";
    EChartEvents["onBrush"] = "brush";
    EChartEvents["onBrushEnd"] = "brushend";
    EChartEvents["onBrushSelected"] = "brushselected";
    EChartEvents["onGlobalCursorTaken"] = "globalcursortaken";
    EChartEvents["onRendered"] = "rendered";
    EChartEvents["onFinished"] = "finished";
})($77503970b015f24f$export$7e005d5daa5fc91b || ($77503970b015f24f$export$7e005d5daa5fc91b = {}));


const $50eed8186559fb03$export$8213d87793e4a80e = (props)=>{
    const echartsRef = (0, $hgUW1$useRef)(null);
    const resizeObserverRef = (0, $hgUW1$useRef)(null);
    const { containerRef: containerRef , theme: theme , renderer: renderer = "svg" , group: group , notMerge: notMerge , lazyUpdate: lazyUpdate , ...restProps } = props;
    (0, $hgUW1$useEffect)(()=>{
        const shouldInitECharts = containerRef.current && !echartsRef.current;
        if (shouldInitECharts) {
            echartsRef.current = startECharts();
            resizeObserverRef.current = startResizeObserver();
        }
        return ()=>{
        // TODO: Review cleanup logic
        // resizeObserverRef.current.unobserve(containerRef.current);
        // resizeObserverRef.current.disconnect();
        // dispose(containerRef.current);
        };
    }, [
        containerRef.current
    ]);
    (0, $hgUW1$useEffect)(renderECharts, [
        theme,
        renderer,
        group,
        notMerge,
        lazyUpdate,
        ...Object.values(restProps).map((el)=>JSON.stringify(el)), 
    ]);
    function startECharts() {
        const echartsInstance = (0, $hgUW1$init)(containerRef.current, theme, {
            renderer: renderer
        });
        // Set group
        echartsInstance.group = group;
        // Set events
        Object.keys((0, $77503970b015f24f$export$7e005d5daa5fc91b)).forEach((eventProp)=>{
            const echartEvent = (0, $77503970b015f24f$export$7e005d5daa5fc91b)[eventProp];
            const eventHandler = restProps[eventProp];
            if (eventHandler) echartsInstance.on(echartEvent, eventHandler);
        });
        return echartsInstance;
    }
    function renderECharts() {
        echartsRef.current?.clear();
        echartsRef.current?.setOption(restProps, notMerge, lazyUpdate);
    }
    function startResizeObserver() {
        const resizeObserver = new ResizeObserver(()=>echartsRef.current?.resize());
        resizeObserver.observe(containerRef.current);
        return resizeObserver;
    }
    return echartsRef.current;
};


$parcel$exportWildcard($ca43fe01b6155439$exports, $50eed8186559fb03$exports);


const $9dc45b7702debb40$export$264f98ddc7eb5f58 = ({ id: id , className: className , style: style , onMount: onMount , onUnmount: onUnmount , onUpdate: onUpdate , ...restProps })=>{
    const containerRef = (0, $hgUW1$useRef)();
    (0, $50eed8186559fb03$export$8213d87793e4a80e)({
        containerRef: containerRef,
        ...restProps
    });
    (0, $hgUW1$useEffect)(()=>{
        if (onMount) onMount();
        return ()=>{
            if (onUnmount) onUnmount();
        };
    }, []);
    (0, $hgUW1$useEffect)(()=>{
        if (onUpdate) onUpdate();
    });
    return /*#__PURE__*/ (0, $hgUW1$react).createElement("div", {
        ref: containerRef,
        id: id,
        className: "react-echarts" + ` ${className || ""}`,
        style: {
            height: "240px",
            width: "100%",
            ...style
        }
    });
};


$parcel$exportWildcard($13be92b15e2953e0$exports, $9dc45b7702debb40$exports);


$parcel$exportWildcard($a69491ea5a126553$exports, $13be92b15e2953e0$exports);






export {$9dc45b7702debb40$export$264f98ddc7eb5f58 as EChart, $50eed8186559fb03$export$8213d87793e4a80e as useECharts, $77503970b015f24f$export$7e005d5daa5fc91b as EChartEvents};
//# sourceMappingURL=module.js.map
